from PyQt5.QtWidgets import QApplication
from PyQt5.QtWebEngineWidgets import QWebEngineProfile, QWebEngineView
from PyQt5.QtWebEngineCore import QWebEngineUrlSchemeHandler
from PyQt5.QtCore import QUrl, QBuffer, QIODevice


handler = None


class SchemeHandler(QWebEngineUrlSchemeHandler):

    def __init__(self, parent=None):
        super().__init__(parent)
        self._keep = []

    def requestStarted(self, job):
        data = b'Hello World'
        buf = QBuffer(data, parent=self)
        self._keep.append(data)
        self._keep.append(buf)
        job.reply(b'text/plain', buf)


def install_scheme_handler():
    global handler
    handler = SchemeHandler(QApplication.instance())
    QWebEngineProfile.defaultProfile().installUrlSchemeHandler(b'test', handler)


app = QApplication([])
install_scheme_handler()
view = QWebEngineView()
view.show()
view.load(QUrl('test:foo'))
app.exec_()
